> For the complete documentation index, see [llms.txt](https://docs.squads.so/main/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.squads.so/main/development/typescript/instructions/create-batch.md).

# Create Batch

Creating a batch for coupling transactions

Batches allow you to approve, reject, cancel, or execute multiple transactions with a single action.&#x20;

When working with batches, you can follow this general procedure:

1. Create a batch&#x20;
2. Create a proposal as a draft&#x20;
3. Add transactions to the batch&#x20;
4. Activate the proposal&#x20;
5. Vote on the proposal&#x20;
6. Execute the proposal

## Example

```typescript
import * as multisig from "@sqds/multisig";
import { Connection, PublicKey } from "@solana/web3.js"

async function main(member: PublicKey) {
    // Cluster Connection
    const connection = new Connection("<your rpc url>");
    
    // If you've saved your createKey, you can define it as a static PublicKey
    const createKey = new PublicKey("<your createkey>")
    
    // Derive the multisig PDA
    const [multisigPda] = multisig.getMultisigPda({
        createKey,
    });
    // or
    // const multisigPda = new PublicKey("<your multisig key>");
    
    // Get deserialized multisig account info
    const multisigInfo = await multisig.accounts.Multisig.fromAccountAddress(
      connection,
      multisigPda
    );

    // Get the current transaction index
    const transactionIndex = Number(multisigInfo.transactionIndex);
    // or, if this is tied to your first transaction
    // const transactionIndex = 1n;
    
    // Create the batch, which we can add transactions to
    const batchCreateIx = await multisig.instructions.batchCreate({
        batchIndex: transactionIndex,
        creator: member,
        multisigPda,
        vaultIndex: 0,
        memo: "Creating a batch",
    });
    
    // Create the proposal for voting on the transactions
    const proposalCreateIx = await multisig.instructions.proposalCreate({
        multisigPda,
        // Created with the same index as the batch
        transactionIndex: transactionIndex,
        creator: member,
        // Proposal is created as a draft
        isDraft: true,
    });
}
```

### Notes

* Batches are for coupling multiple vault transactions under one proposal
* They have their own `transactionIndex` context, starting at 1


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.squads.so/main/development/typescript/instructions/create-batch.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
